#include <stdlib.h>
#include <string>
#include <windows.h>


extern "C"
{
	typedef struct __declspec(dllexport) tagRECTD
	{
		double    left;
		double    top;
		double    right;
		double    bottom;
	} RECTD;

	class Unmanaged
	// event receiver
	{
	public:
		virtual void OnSelectionChanged(){ }
		virtual void OnDataLoaded(){ }
		virtual void OnActiveLayerChanged(){ }

	};

	__declspec(dllexport) void __stdcall GetErrorLog(LPSTR retArray, DWORD size);
	__declspec(dllexport) int __stdcall LoadData(char*);
	__declspec(dllexport) int __stdcall CreateImage(char*, char*, int);
	__declspec(dllexport) int __stdcall CreateImage2(std::string, char *, int, bool, int, double, double, double, double);
	__declspec(dllexport) int __stdcall CreateImage3(std::string, char *, int, bool, int, double, double, double, double, int, int);
	__declspec(dllexport) int __stdcall LoadGerberLayerAndReturnLayerName(char*, LPSTR, DWORD);
	__declspec(dllexport) bool	__stdcall GetLayerBounds(char*, RECTD*);
	__declspec(dllexport) bool __stdcall  GetStepBounds(RECTD*);
	__declspec(dllexport) void __stdcall RotateData(char*, bool);
	__declspec(dllexport) void __stdcall RotateAndMirrorStep(double, bool,bool);
	__declspec(dllexport) void __stdcall Oversize(char*, double);
	__declspec(dllexport) void __stdcall Save();
	__declspec(dllexport) void __stdcall CloseJob();
	__declspec(dllexport) void __stdcall DisposeAllResources();
	__declspec(dllexport) void __stdcall ClearLog();
	__declspec(dllexport) void __stdcall ShowPCBIWindow();
	__declspec(dllexport) bool __stdcall 	 PCBInvestigatorVisible();
	__declspec(dllexport) void __stdcall 	 HighlightCMP(char*   CMPReference);
	__declspec(dllexport) void __stdcall 	 ZoomToCMP(char*   CMPReference);
	__declspec(dllexport) void __stdcall 	 ClearAllSelections();
	__declspec(dllexport) void __stdcall 	 ActivateLayersForSelectedObjects();
	__declspec(dllexport) bool __stdcall 	 RegisterEvent(Unmanaged*  eventHandlingClass);
	__declspec(dllexport) void __stdcall GetCMPInfo(char*   CMPReference, LPSTR retArray, DWORD size);

}